/***************************************************************************
                          roamingservice.h -  description
                             -------------------
    begin                : sun Jan 4 2009
    copyright            : (C) 2009 by Antonio Nastasi
    email                : sifcenter(at)gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ROAMINGSERVICE_H
#define ROAMINGSERVICE_H

#include "passportloginservice.h"



/**
 * @brief Soap actions for retrieve the address book and membership lists.
 *
 *
 * @author Antonio Nastasi
 * @ingroup NetworkSoap
 */
class RoamingService : public PassportLoginService
{
  Q_OBJECT

  public:
    // Constructor
                    RoamingService( QObject *parent );
    // Destructor
                   ~RoamingService();
    // Get the profile for given cid
    void            getProfile( const QString& cid );

  private: // Private method
    // Create the commod header
    QString         createCommonHeader() const;
    // Parse the SOAP fault
    void            parseSecureFault( SoapMessage *message );
    // The connection received the full response
    void            parseSecureResult( SoapMessage *message );
};

#endif
