/***************************************************************************
                          kmessdbusadaptor.cpp -  description
                             -------------------
    begin                : Wednesday July 10 2008
    copyright            : (C) 2008 by Ruben Vandamme
    email                : vandammeru gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "utils/kmessdbusadaptor.h"

#include <QtCore/QMetaObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>



// constructor
RemoteControlAdaptor::RemoteControlAdaptor( KMessDBus *parent )
    : QDBusAbstractAdaptor( parent )
{
    setAutoRelaySignals( true );
}



// destructor
RemoteControlAdaptor::~RemoteControlAdaptor()
{
}

inline KMessDBus* RemoteControlAdaptor::parent() const
{
  return static_cast<KMessDBus*>( QObject::parent() );
}


// handle method call org.kmess.remoteControl.connect
void RemoteControlAdaptor::connect()
{
    parent()->connect();
}



// handle method call org.kmess.remoteControl.disconnect
void RemoteControlAdaptor::disconnect()
{
    parent()->disconnect();
}



// handle method call org.kmess.remoteControl.getFriendlyName
QString RemoteControlAdaptor::getFriendlyName()
{
    return parent()->getFriendlyName();
}



// handle method call org.kmess.remoteControl.getFriendlyName
QString RemoteControlAdaptor::getFriendlyName( int formattingMode )
{
    return parent()->getFriendlyName(formattingMode);
}



// handle method call org.kmess.remoteControl.getStatus
int RemoteControlAdaptor::getStatus()
{
    return parent()->getStatus();
}



// handle method call org.kmess.remoteControl.isConnected
bool RemoteControlAdaptor::isConnected()
{
    return parent()->isConnected();
}



// handle method call org.kmess.remoteControl.setStatus
void RemoteControlAdaptor::setStatus(int status)
{
    parent()->setStatus(status);
}



// handle method call org.kmess.remoteControl.getList
QList<DBusContact> RemoteControlAdaptor::getList()
{
    return parent()->getList();
}



// handle method call org.kmess.remoteControl.requestChat
void RemoteControlAdaptor::requestChat( QString handle )
{
    parent()->requestChat(handle);
}



// handle method call org.kmess.remoteControl.startFileTransfer
void RemoteControlAdaptor::startFileTransfer( QString handle, QString file )
{
    parent()->startFileTransfer(handle,file);
}



#include "kmessdbusadaptor.moc"
