/***************************************************************************
                          kmessdbusadaptor.h -  description
                             -------------------
    begin                : Wednesday July 10 2008
    copyright            : (C) 2008 by Ruben Vandamme
    email                : vandammeru gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMESSDBUSADAPTOR_H
#define KMESSDBUSADAPTOR_H

#include "utils/kmessdbus.h"

#include <QtCore/QObject>
#include <QtDBus/QtDBus>



class QByteArray;
template<class T> class QList;
template<class Key, class Value> class QMap;
class QString;
class QStringList;
class QVariant;



class RemoteControlAdaptor: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.kmess.remoteControl")
    Q_CLASSINFO("D-Bus Introspection", ""
      "  <interface name=\"org.kmess.remoteControl\" >\n"
      "    <method name=\"connect\" />\n"
      "    <method name=\"disconnect\" />\n"
      "    <method name=\"isConnected\" >\n"
      "      <arg direction=\"out\" type=\"b\" name=\"isConnected\" />\n"
      "    </method>\n"
      "    <method name=\"setStatus\" >\n"
      "      <arg direction=\"in\" type=\"i\" name=\"status\" />\n"
      "    </method>\n"
      "    <method name=\"getStatus\" >\n"
      "      <arg direction=\"out\" type=\"i\" name=\"status\" />\n"
      "    </method>\n"
      "    <method name=\"getFriendlyname\" >\n"
      "      <arg direction=\"in\" type=\"i\" name=\"formattingMode\" />\n"
      "      <arg direction=\"out\" type=\"s\" name=\"friendlyName\" />\n"
      "    </method>\n"
      "    <method name=\"getFriendlyname\" >\n"
      "      <arg direction=\"out\" type=\"s\" name=\"friendlyName\" />\n"
      "    </method>\n"
      "    <method name=\"getList\">\n"
      "      <arg name=\"list\" type=\"a(ssi)\" direction=\"out\"/>\n"
      "    </method>\n"
      "  </interface>\n"
      "")

public: // Public methods
    // Constructor
                       RemoteControlAdaptor( KMessDBus *parent );
    // Destructor
    virtual           ~RemoteControlAdaptor();

    // Get parent
    inline KMessDBus  *parent() const;

public slots: // Public slots
    // handle method call org.kmess.remoteControl.connect
    void               connect();
    // handle method call org.kmess.remoteControl.disconnect
    void               disconnect();
    // handle method call org.kmess.remoteControl.getFriendlyName
    QString            getFriendlyName();
    // handle method call org.kmess.remoteControl.getFriendlyName
    QString            getFriendlyName( int formattingMode );
    // handle method call org.kmess.remoteControl.getStatus
    int                getStatus();
    // handle method call org.kmess.remoteControl.isConnected
    bool               isConnected();
    // handle method call org.kmess.remoteControl.setStatus
    void               setStatus( int status );
    // handle method call org.kmess.remoteControl.getList
    QList<DBusContact> getList();
    // handle method call org.kmess.remoteControl.requestChat
    void               requestChat( QString handle );
    // handle method call org.kmess.remoteControl.startFileTransfer
    void               startFileTransfer( QString handle, QString filename );
};



#endif
