

#ifndef LIKEBACKBAR_H
#define LIKEBACKBAR_H

#include <QTimer>
#include <QWidget>

#include "likeback.h"

#include "ui_likebackbar.h"



class LikeBackBar : public QWidget, private Ui::LikeBackBar
{
  Q_OBJECT

  public:
    // Constructor
             LikeBackBar( LikeBack *likeBack );
    // Destructor
            ~LikeBackBar();

  public slots:
    // Begin moving the bar
    void     startTimer();
    // End moving the bar
    void     stopTimer();

  private slots:
    // Move the bar where the parent window is
    void     autoMove();
    // The Like button has been clicked
    void     likeClicked();
    // The Dislike button has been clicked
    void     dislikeClicked();
    // The Bug button has been clicked
    void     bugClicked();
    // The Feature button has been clicked
    void     featureClicked();

  private:
    // The parent LikeBack instance
    LikeBack *m_likeBack;
    // Timer to adjust the bar position
    QTimer    m_timer;

};

#endif
